Bug 44751 - Incorrect code flow analysis with goto and out parameter causes CS0177
Summary: Incorrect code flow analysis with goto and out parameter causes CS0177
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: unspecified
Hardware: PC Windows
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2016-09-26 18:56 UTC by Jonathan Chambers
Modified: 2016-09-29 20:42 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:


Attachments

Description Jonathan Chambers 2016-09-26 18:56:59 UTC
The following code fails to compile with Mono C# compiler while it compiles successfully with csc (or an older mono C# compiler).

GotoOutBug.cs(3,45): error CS0177: The out parameter `x' must be assigned to before control leaves the current method 
Compilation failed: 1 error(s), 0 warnings

public class GotoCodeFlowBug
{
	public static void Test(bool cond, out int x)
	{
		if (cond)
		{
			goto Label;
		}
		Label:
		x = 0;
	}
}
Comment 1 Marek Safar 2016-09-29 20:42:14 UTC
Fixed in master and Mono 4.8

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.


Create a new report for Bug 44751 on Developer Community or GitHub if you have new information to add and do not yet see a matching report.

  • Export the original title and description: Developer Community HTML or GitHub Markdown
  • Copy the title and description into the new report. Adjust them to be up-to-date if needed.
  • Add your new information.

In special cases on GitHub you might also want the comments: GitHub Markdown with public comments


Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Related Links: